library(ggplot2)
library(tidyverse)
library(dplyr)
getwd()
setwd("C:/Users/Jason/Desktop")

data=read.csv("Figure 9 drug related GEO-GSEA verification.txt",sep = "\t")
colnames(data)
#data=data[,c("Terms","groups","observed.gene.count","NES","FDR" ,"-LOG10FDR")]

colnames(data)=c("Terms","groups","counts","NES","FDR","-LOG10FDR")
class(data$`-LOG10FDR`)
#data$"-Log10FDR"= -1 * log10(data$FDR)

data$groups=as.factor(data$groups)



mytheme <- theme(axis.title=element_text(face="bold", size=10,colour = 'gray25'), #???????????????
                 axis.text=element_text(face="bold", size=10,colour = 'gray25'), #???????????????
                 axis.line = element_line(size=0.5, colour = 'black'), #??????
                 panel.background = element_rect(color='black'), #???????????????
                 legend.key = element_blank() #??????????????????
) 





p<-ggplot(data,aes(groups,Terms)) +
  geom_point(aes(fill=NES,size=-log10(FDR)),alpha=0.9,pch=21,colour="gray25") +  #fill?????????????????????,colour?????????????????????
  scale_fill_gradient(low='BLUE', high='RED',breaks=c(-2,-1.5,-1,-0.5,0,0.5,1,1.5,2)) + #???????????????????????????
  scale_size_area(max_size = 10, breaks=c(0,0.5,1,1.5,2,2.5,3)) + #???????????????????????????????????????????????????
  labs(y='',x='',fill='NES',size='-log10(FDR)')





p+mytheme












p = ggplot(data,aes(groups,Terms)) 
p=p + geom_point()  



p=p + geom_point(aes(size=-log10(FDR))


pbubble = p+ geom_point(aes(size=-log10(FDR),color=NES))


pr = pbubble+scale_color_gradient(low="blue",high = "red", breaks = c(-2,-1,0,1,2))


pr = pr+labs(color="NES",size="-LOG10FDR",  
             x="groups",y="Terms",title="GSEA results of selected drugs in glioma")+
  scale_color_continuous(low = 'darkblue', high = 'darkred', breaks = c(-2,-1,0,1,2))+
  scale_size_area(max_size = 10,breaks = c(0,0.5,1,1.5,2)) +
  xlim("mifepristone-GSE59262","tretinoin-GSE17227","tretinoin-GSE61002","tretinoin-GSE141789")

#+ coord_fixed(ratio=1/20)
   
  
  
pr + theme_bw()


## ????????????
ggsave("KEGG.pdf")# ?????????pdf??????
ggsave("out2.png",width=4,height=4)# ??????????????????
---------------