library(ggplot2)
library(tidyverse)
library(dplyr)
getwd()
setwd("C:/Users/Jason/Desktop")

data=read.csv("1076 Genes Functional enrichment KEGG-selected.txt",sep = "\t")
colnames(data)
data=data[,c("Terms","observed.gene.count","strength","false.discovery.rate" )]

colnames(data)=c("Term","Count","Strength","FDR")
data$"-Log10FDR"= -1 * log10(data$FDR)


p = ggplot(data,aes(Strength,Term))
p=p + geom_point()  
# ??????????????????
p=p + geom_point(aes(size=Count))
# ??????????????????
pbubble = p+ geom_point(aes(size=Count,color=-1*log10(FDR)))
# ???????????????
pr = pbubble+scale_color_gradient(low="skyblue",high = "red")
# ??????p?????????
pr = pr+labs(color=expression(-log[10](FDR)),size="Count",  
             x="Strength",y="Terms",title="KEGG")+
  scale_color_continuous(low = 'skyblue', high = 'darkblue', breaks = c(2,4,6,8,10,12))+
  scale_size_area(max_size = 10,breaks = c(0,100,200,300,400,500)) + coord_fixed(ratio=1/20)
   
  
  
pr + theme_bw()


## ????????????
ggsave("KEGG.pdf")# ?????????pdf??????
ggsave("out2.png",width=4,height=4)# ??????????????????
---------------